
/*

  KLayout Layout Viewer
  Copyright (C) 2006-2007 Matthias Koefferlein

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/


#include <QtGui/QApplication>
#include <QtGui/QFont>
#include <QtGui/QBitmap>
#include <QtGui/QPainter>
#include <QtGui/QFontDialog>

#include <stdio.h>

int 
main (int argc, char *argv [])
{
  QApplication app (argc, argv);

  printf ("\n// generated by fontgen\n// DO NOT EDIT !\n\n");

  printf ("\nnamespace lay {\n\n");

  QFont f ("B&H LucidaTypewriter", 12);
  f.setStyleStrategy(QFont::StyleStrategy ((f.styleStrategy() & ~QFont::PreferAntialias) | QFont::NoAntialias));

  for (int os = 1; os < 4; ++os) {

    //  select font
    bool ok = true;
    f = QFontDialog::getFont (&ok, f);
    if (!ok) {
      return 1;
    }

    f.setStyleStrategy(QFont::StyleStrategy ((f.styleStrategy() & ~QFont::PreferAntialias) | QFont::NoAntialias));

    QFontMetrics fm (f);

    printf ("// Font: %s\n", f.toString ().ascii ());
    printf ("const unsigned int ff%d_height = %d;\nconst unsigned int ff%d_line_height = %d;\nconst unsigned int ff%d_width = %d;\n",
      os, fm.height (), os, fm.lineSpacing (), os, fm.width ('W'));

    printf ("const unsigned char ff%d_first_char = ' ';\n\nuint32_t ff%d_data [] = {\n", os, os);

    for (int c = ' '; c < 256; ++c) {

      QBitmap b (fm.width ('W'), fm.height (), true);
      QPainter p (&b);
      p.setRenderHints (QPainter::TextAntialiasing, false);
      p.setFont (f);

      char t[2];
      t[0] = c;
      t[1] = 0;
      p.drawText (0, fm.ascent (), t);

      QImage img (b.convertToImage ());

      printf ("  // %d\n  ", c);
      for (int i = 0; i < fm.height (); ++i) {
        if (i > 0) {
          printf (", ");
        }
        printf ("0x%x", *(int *)img.scanLine (i) & ((1 << fm.width ('W')) - 1));
      }
      printf (",\n");

    }

    printf ("};\n");

  }

  printf ("\n} // namespace lay\n");

  return 0;
}


