
/*

  KLayout Layout Viewer
  Copyright (C) 2006-2007 Matthias Koefferlein

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/


#include "gsiDecl.h"

#include <string.h>

#include "tlString.h"

// --------------------------------------------------------------------------------
//

namespace gsi
{

std::string
ArgType::to_string () const
{
  std::string s;
  switch (type) {
  case T_void:
    s = "void"; break;
  case T_bool:
    s = "bool"; break;
  case T_int:
    s = "int"; break;
  case T_uint:
    s = "unsigned int"; break;
  case T_long:
    s = "long"; break;
  case T_ulong:
    s = "unsigned long"; break;
  case T_longlong:
    s = "long long"; break;
  case T_ulonglong:
    s = "unsigned long long"; break;
  case T_double:
    s = "double"; break;
  case T_string_ccptr:
    s = "const char *"; break;
  case T_string:
    s = "string"; break;
  case T_var:
    s = "variant"; break;
  case T_object_ref:
    s = cls->name () + "&"; break;
  case T_object_cref:
    s = "const " + cls->name () + "&"; break;
  case T_object_new:
    s = "new " + cls->name () + "&"; break;
  case T_object:
    s = cls->name (); break;
  }
  if (vector) {
    s += "[]";
  }
  return s;
}

}

