
/*

  KLayout Layout Viewer
  Copyright (C) 2006-2007 Matthias Koefferlein

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/


#ifndef _HDR_gsiEvents
#define _HDR_gsiEvents

//  For a comprehensive documentation see gsi.h

namespace gsi
{

template <class A1 = void, class A2 = void, class A3 = void, class A4 = void, 
          class A5 = void, class A6 = void, class A7 = void, class A8 = void, 
          class A9 = void, class A10 = void, class A11 = void> 
class event;

template <class R,
          class A1 = void, class A2 = void, class A3 = void, class A4 = void, 
          class A5 = void, class A6 = void, class A7 = void, class A8 = void, 
          class A9 = void, class A10 = void, class A11 = void> 
class event_with_return;

// 0 arguments

#define  _COUNT 0
#define _TMPLARGS     
#define _TMPLARGPART  
#define _TMPLARGLIST  void, void, void, void, void, void, void, void, void, void, void
#define _FUNCARGLIST  
#define _CALLARGLIST  
#define _SETVALUE     

#include "gsiEventsVar.h"

#undef _SETVALUE
#undef _CALLARGLIST
#undef _FUNCARGLIST
#undef _TMPLARGLIST
#undef _TMPLARGPART
#undef _TMPLARGS
#undef _COUNT

// 1 argument

#define  _COUNT 1
#define _TMPLARGS     class A1
#define _TMPLARGPART  , class A1
#define _TMPLARGLIST  A1, void, void, void, void, void, void, void, void, void, void
#define _FUNCARGLIST  A1
#define _CALLARGLIST  A1 a1
#define _SETVALUE     args.set_value (typename type_traits<A1>::tag (), (A1) a1); \

#include "gsiEventsVar.h"

#undef _SETVALUE
#undef _CALLARGLIST
#undef _FUNCARGLIST
#undef _TMPLARGLIST
#undef _TMPLARGPART
#undef _TMPLARGS
#undef _COUNT

// 2 arguments

#define  _COUNT 2
#define _TMPLARGS     class A1, class A2
#define _TMPLARGPART  , class A1, class A2
#define _TMPLARGLIST  A1, A2, void, void, void, void, void, void, void, void, void
#define _FUNCARGLIST  A1, A2
#define _CALLARGLIST  A1 a1, A2 a2
#define _SETVALUE     args.set_value (typename type_traits<A1>::tag (), (A1) a1); \
                      args.set_value (typename type_traits<A2>::tag (), (A2) a2); \

#include "gsiEventsVar.h"

#undef _SETVALUE
#undef _CALLARGLIST
#undef _FUNCARGLIST
#undef _TMPLARGLIST
#undef _TMPLARGPART
#undef _TMPLARGS
#undef _COUNT

// 3 arguments

#define  _COUNT 3
#define _TMPLARGS     class A1, class A2, class A3
#define _TMPLARGPART  , class A1, class A2, class A3
#define _TMPLARGLIST  A1, A2, A3, void, void, void, void, void, void, void, void
#define _FUNCARGLIST  A1, A2, A3
#define _CALLARGLIST  A1 a1, A2 a2, A3 a3
#define _SETVALUE     args.set_value (typename type_traits<A1>::tag (), (A1) a1); \
                      args.set_value (typename type_traits<A2>::tag (), (A2) a2); \
                      args.set_value (typename type_traits<A3>::tag (), (A3) a3); \

#include "gsiEventsVar.h"

#undef _SETVALUE
#undef _CALLARGLIST
#undef _FUNCARGLIST
#undef _TMPLARGLIST
#undef _TMPLARGPART
#undef _TMPLARGS
#undef _COUNT

// 4 arguments

#define  _COUNT 4
#define _TMPLARGS     class A1, class A2, class A3, class A4
#define _TMPLARGPART  , class A1, class A2, class A3, class A4
#define _TMPLARGLIST  A1, A2, A3, A4, void, void, void, void, void, void, void
#define _FUNCARGLIST  A1, A2, A3, A4
#define _CALLARGLIST  A1 a1, A2 a2, A3 a3, A4 a4
#define _SETVALUE     args.set_value (typename type_traits<A1>::tag (), (A1) a1); \
                      args.set_value (typename type_traits<A2>::tag (), (A2) a2); \
                      args.set_value (typename type_traits<A3>::tag (), (A3) a3); \
                      args.set_value (typename type_traits<A4>::tag (), (A4) a4); \

#include "gsiEventsVar.h"

#undef _SETVALUE
#undef _CALLARGLIST
#undef _FUNCARGLIST
#undef _TMPLARGLIST
#undef _TMPLARGPART
#undef _TMPLARGS
#undef _COUNT

// 5 arguments

#define  _COUNT 5
#define _TMPLARGS     class A1, class A2, class A3, class A4, class A5
#define _TMPLARGPART  , class A1, class A2, class A3, class A4, class A5
#define _TMPLARGLIST  A1, A2, A3, A4, A5, void, void, void, void, void, void
#define _FUNCARGLIST  A1, A2, A3, A4, A5
#define _CALLARGLIST  A1 a1, A2 a2, A3 a3, A4 a4, A5 a5
#define _SETVALUE     args.set_value (typename type_traits<A1>::tag (), (A1) a1); \
                      args.set_value (typename type_traits<A2>::tag (), (A2) a2); \
                      args.set_value (typename type_traits<A3>::tag (), (A3) a3); \
                      args.set_value (typename type_traits<A4>::tag (), (A4) a4); \
                      args.set_value (typename type_traits<A5>::tag (), (A5) a5); \

#include "gsiEventsVar.h"

#undef _SETVALUE
#undef _CALLARGLIST
#undef _FUNCARGLIST
#undef _TMPLARGLIST
#undef _TMPLARGPART
#undef _TMPLARGS
#undef _COUNT

// 6 arguments

#define  _COUNT 6
#define _TMPLARGS     class A1, class A2, class A3, class A4, class A5, class A6
#define _TMPLARGPART  , class A1, class A2, class A3, class A4, class A5, class A6
#define _TMPLARGLIST  A1, A2, A3, A4, A5, A6, void, void, void, void, void
#define _FUNCARGLIST  A1, A2, A3, A4, A5, A6
#define _CALLARGLIST  A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6
#define _SETVALUE     args.set_value (typename type_traits<A1>::tag (), (A1) a1); \
                      args.set_value (typename type_traits<A2>::tag (), (A2) a2); \
                      args.set_value (typename type_traits<A3>::tag (), (A3) a3); \
                      args.set_value (typename type_traits<A4>::tag (), (A4) a4); \
                      args.set_value (typename type_traits<A5>::tag (), (A5) a5); \
                      args.set_value (typename type_traits<A6>::tag (), (A6) a6); \

#include "gsiEventsVar.h"

#undef _SETVALUE
#undef _CALLARGLIST
#undef _FUNCARGLIST
#undef _TMPLARGLIST
#undef _TMPLARGPART
#undef _TMPLARGS
#undef _COUNT

// 7 arguments

#define  _COUNT 7
#define _TMPLARGS     class A1, class A2, class A3, class A4, class A5, class A6, class A7
#define _TMPLARGPART  , class A1, class A2, class A3, class A4, class A5, class A6, class A7
#define _TMPLARGLIST  A1, A2, A3, A4, A5, A6, A7, void, void, void, void
#define _FUNCARGLIST  A1, A2, A3, A4, A5, A6, A7
#define _CALLARGLIST  A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7
#define _SETVALUE     args.set_value (typename type_traits<A1>::tag (), (A1) a1); \
                      args.set_value (typename type_traits<A2>::tag (), (A2) a2); \
                      args.set_value (typename type_traits<A3>::tag (), (A3) a3); \
                      args.set_value (typename type_traits<A4>::tag (), (A4) a4); \
                      args.set_value (typename type_traits<A5>::tag (), (A5) a5); \
                      args.set_value (typename type_traits<A6>::tag (), (A6) a6); \
                      args.set_value (typename type_traits<A7>::tag (), (A7) a7); \

#include "gsiEventsVar.h"

#undef _SETVALUE
#undef _CALLARGLIST
#undef _FUNCARGLIST
#undef _TMPLARGLIST
#undef _TMPLARGPART
#undef _TMPLARGS
#undef _COUNT

// 8 arguments

#define  _COUNT 8
#define _TMPLARGS     class A1, class A2, class A3, class A4, class A5, class A6, class A7, class A8
#define _TMPLARGPART  , class A1, class A2, class A3, class A4, class A5, class A6, class A7, class A8
#define _TMPLARGLIST  A1, A2, A3, A4, A5, A6, A7, A8, void, void, void
#define _FUNCARGLIST  A1, A2, A3, A4, A5, A6, A7, A8
#define _CALLARGLIST  A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8
#define _SETVALUE     args.set_value (typename type_traits<A1>::tag (), (A1) a1); \
                      args.set_value (typename type_traits<A2>::tag (), (A2) a2); \
                      args.set_value (typename type_traits<A3>::tag (), (A3) a3); \
                      args.set_value (typename type_traits<A4>::tag (), (A4) a4); \
                      args.set_value (typename type_traits<A5>::tag (), (A5) a5); \
                      args.set_value (typename type_traits<A6>::tag (), (A6) a6); \
                      args.set_value (typename type_traits<A7>::tag (), (A7) a7); \
                      args.set_value (typename type_traits<A8>::tag (), (A8) a8); \

#include "gsiEventsVar.h"

#undef _SETVALUE
#undef _CALLARGLIST
#undef _FUNCARGLIST
#undef _TMPLARGLIST
#undef _TMPLARGPART
#undef _TMPLARGS
#undef _COUNT

// 9 arguments

#define  _COUNT 9
#define _TMPLARGS     class A1, class A2, class A3, class A4, class A5, class A6, class A7, class A8, class A9
#define _TMPLARGPART  , class A1, class A2, class A3, class A4, class A5, class A6, class A7, class A8, class A9
#define _TMPLARGLIST  A1, A2, A3, A4, A5, A6, A7, A8, A9, void, void
#define _FUNCARGLIST  A1, A2, A3, A4, A5, A6, A7, A8, A9
#define _CALLARGLIST  A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9
#define _SETVALUE     args.set_value (typename type_traits<A1>::tag (), (A1) a1); \
                      args.set_value (typename type_traits<A2>::tag (), (A2) a2); \
                      args.set_value (typename type_traits<A3>::tag (), (A3) a3); \
                      args.set_value (typename type_traits<A4>::tag (), (A4) a4); \
                      args.set_value (typename type_traits<A5>::tag (), (A5) a5); \
                      args.set_value (typename type_traits<A6>::tag (), (A6) a6); \
                      args.set_value (typename type_traits<A7>::tag (), (A7) a7); \
                      args.set_value (typename type_traits<A8>::tag (), (A8) a8); \
                      args.set_value (typename type_traits<A9>::tag (), (A9) a9); \

#include "gsiEventsVar.h"

#undef _SETVALUE
#undef _CALLARGLIST
#undef _FUNCARGLIST
#undef _TMPLARGLIST
#undef _TMPLARGPART
#undef _TMPLARGS
#undef _COUNT

// 10 arguments

#define  _COUNT 10
#define _TMPLARGS     class A1, class A2, class A3, class A4, class A5, class A6, class A7, class A8, class A9, class A10
#define _TMPLARGPART  , class A1, class A2, class A3, class A4, class A5, class A6, class A7, class A8, class A9, class A10
#define _TMPLARGLIST  A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, void
#define _FUNCARGLIST  A1, A2, A3, A4, A5, A6, A7, A8, A9, A10
#define _CALLARGLIST  A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10
#define _SETVALUE     args.set_value (typename type_traits<A1>::tag (), (A1) a1); \
                      args.set_value (typename type_traits<A2>::tag (), (A2) a2); \
                      args.set_value (typename type_traits<A3>::tag (), (A3) a3); \
                      args.set_value (typename type_traits<A4>::tag (), (A4) a4); \
                      args.set_value (typename type_traits<A5>::tag (), (A5) a5); \
                      args.set_value (typename type_traits<A6>::tag (), (A6) a6); \
                      args.set_value (typename type_traits<A7>::tag (), (A7) a7); \
                      args.set_value (typename type_traits<A8>::tag (), (A8) a8); \
                      args.set_value (typename type_traits<A9>::tag (), (A9) a9); \
                      args.set_value (typename type_traits<A10>::tag (), (A10) a10); \

#include "gsiEventsVar.h"

#undef _SETVALUE
#undef _CALLARGLIST
#undef _FUNCARGLIST
#undef _TMPLARGLIST
#undef _TMPLARGPART
#undef _TMPLARGS
#undef _COUNT

// 11 arguments

#define  _COUNT 11
#define _TMPLARGS     class A1, class A2, class A3, class A4, class A5, class A6, class A7, class A8, class A9, class A10, class A11
#define _TMPLARGPART  , class A1, class A2, class A3, class A4, class A5, class A6, class A7, class A8, class A9, class A10, class A11
#define _TMPLARGLIST  A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11
#define _FUNCARGLIST  A1, A2, A3, A4, A5, A6, A7, A8, A9, A10, A11
#define _CALLARGLIST  A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7, A8 a8, A9 a9, A10 a10, A11 a11
#define _SETVALUE     args.set_value (typename type_traits<A1>::tag (), (A1) a1); \
                      args.set_value (typename type_traits<A2>::tag (), (A2) a2); \
                      args.set_value (typename type_traits<A3>::tag (), (A3) a3); \
                      args.set_value (typename type_traits<A4>::tag (), (A4) a4); \
                      args.set_value (typename type_traits<A5>::tag (), (A5) a5); \
                      args.set_value (typename type_traits<A6>::tag (), (A6) a6); \
                      args.set_value (typename type_traits<A7>::tag (), (A7) a7); \
                      args.set_value (typename type_traits<A8>::tag (), (A8) a8); \
                      args.set_value (typename type_traits<A9>::tag (), (A9) a9); \
                      args.set_value (typename type_traits<A10>::tag (), (A10) a10); \
                      args.set_value (typename type_traits<A11>::tag (), (A11) a11); \

#include "gsiEventsVar.h"

#undef _SETVALUE
#undef _CALLARGLIST
#undef _FUNCARGLIST
#undef _TMPLARGLIST
#undef _TMPLARGPART
#undef _TMPLARGS
#undef _COUNT

typedef event<void, void, void, void, void, void, void, void, void, void, void>  Event;

}

#endif

